//+------------------------------------------------------------------+
//|                                                  treideri_v1.mq4 |
//|                                     coded by nezinu, treideri.lv |
//|                                                  www.treideri.lv |
//+------------------------------------------------------------------+
#property copyright "coded by nezinu, treideri.lv"
#property link      "www.treideri.lv"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red


extern int fast = 25;
extern int slow = 50;
extern int signal = 4;
extern int periods = 15;
extern int augsRob = 95;
extern int apaksRob = 5;
extern int maPerS = 200;
extern int maPerF = 50;
extern int envPer = 50;
extern double envDev = 1.0;
extern int timeFreims = 1440;

double up[],down[];
double maS1[],maF1[],imacd[],envup[],envdown[];

bool sellSignal, buySignal;


int init()
  {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0,233);
      SetIndexBuffer(0,up);
      SetIndexEmptyValue(0,0);
      
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1,234);
      SetIndexBuffer(1,down);
      SetIndexEmptyValue(1,0);
      
      
   return(0);
  }


int start()
  {
   int    counted_bars=IndicatorCounted();
   int limit, vakardiena, vakardiena1;
   double macd,highmacd, lowmacd, temp,macdS,highmacdS, lowmacdS,tempS;
   if(counted_bars == 0) limit = Bars-periods-1;
   if(counted_bars > 0) limit = Bars-counted_bars-1;
   
   
   ArrayResize(maS1, Bars+1);
   ArrayResize(maF1, Bars+1);
   ArrayResize(imacd, Bars+1);
   ArrayResize(envup, Bars+1);
    ArrayResize(envdown, Bars+1);
   
   for(int i=limit;i>=0;i--)
      {
         maS1[i] = iMA(Symbol(),timeFreims, maPerS, 0, MODE_SMA, PRICE_CLOSE, iBarShift(Symbol(),timeFreims,Time[i]));
         maF1[i] = iMA(Symbol(),timeFreims, maPerF, 0, MODE_SMA, PRICE_CLOSE, iBarShift(Symbol(),timeFreims,Time[i]));
         envup[i] = iEnvelopes(Symbol(), 0, envPer, MODE_SMA, 0, PRICE_CLOSE, envDev, MODE_UPPER, i);
         envdown[i] = iEnvelopes(Symbol(), 0, envPer, MODE_SMA, 0, PRICE_CLOSE, envDev, MODE_LOWER, i);
         up[i] = NULL;
         down[i] = NULL;
         
         for(int cnt=i+periods; cnt>=i; cnt--)
            {         
               macd=iMACD(Symbol(),0, fast, slow, signal, PRICE_CLOSE, MODE_SIGNAL,cnt);
               if (cnt == i+periods)
                  { 
                     highmacd = macd;
                     lowmacd = macd;
                  }
               if(macd>highmacd) highmacd = macd;
               if(macd<lowmacd) lowmacd = macd; 
            }
        
       imacd[i] = (macd - lowmacd)/(highmacd - lowmacd)*100;
      
       if(imacd[i]<augsRob) sellSignal = FALSE;
       if(imacd[i]>apaksRob) buySignal = FALSE;
       if(imacd[i+1]<augsRob && imacd[i]>augsRob) sellSignal = TRUE;
       if(imacd[i+1]>apaksRob && imacd[i]<apaksRob) buySignal = TRUE;
      
       
       
       if(TimeDayOfWeek(Time[i+2]) == 0) vakardiena1 = i+3; else vakardiena1 = i+2;
       if(TimeDayOfWeek(Time[i+1]) == 0)
         {
            vakardiena = i+2;
            vakardiena1 = i+3;  
         } else vakardiena = i+1;
       
       if(sellSignal && Close[i]>envdown[i] && maF1[i]<maS1[i] && Close[i]<Close[vakardiena] && Low[i]<Low[vakardiena]  && Close[i]<Close[vakardiena1] && Low[i]<Low[vakardiena1])
         {
            down[i] = Close[i];
            up[i]= NULL;
            sellSignal = FALSE;
         }
       if(buySignal && Close[i]<envup[i] && maF1[i]>maS1[i] && Close[i]>Close[vakardiena] && High[i]>High[vakardiena]  && Close[i]>Close[vakardiena1] && High[i]>High[vakardiena1])
         {
            up[i]=Close[i];
            down[i] = NULL;
            buySignal = FALSE;
         
         }
       
        
      }
   return(0);
  }
//+------------------------------------------------------------------+